#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "bergenListener.h"
#include "bergenServer.h"
#include "bergenAmplitude.h"


// The constructor must be given the server object pointer. The Sound Object 
// itself is created by snerd on snerd's side.  Snerd is managing the data and 
// return just the Handle to it 
bergenAmplitude::bergenAmplitude(bergenServer *server) : bergenSound(server)
	{
	amplitude_ = 0;
	createRemote();
printf("create\n");
	}


// Process a message from the server
void bergenAmplitude::message(char **msg,int numStrings)
	{
	if (!strcasecmp(msg[0],"amplitude"))
		amplitude_ = atof(msg[1]);
	else
		bergenSound::message(msg,numStrings);
	}

// Sends message to the associated server to create a sound sample 
// and waits for the resulting handle to store
void bergenAmplitude::createRemote(void)
	{
	if (server_)
		{
		char cmd[256];
		sprintf(cmd,"-1 new amplitude %d",server_->listener()->handle());
		server_->sendMessage(cmd);
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Returns the total amplitude of the input. If the server message faild,
// this will return 0. Note that this* function requires sending a message to 
// the server and waiting for the response, so it is potentially slow.
float bergenAmplitude::amplitude(void)
	{
	if (server_)
		{
		char cmd[256];
		sprintf(cmd,"%d getamplitude", handle_);
		server_->sendMessage(cmd);
		}
	return amplitude_;
	}
