#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "bergenListener.h"
#include "bergenServer.h"
#include "bergenRecord.h"


// The constructor must be given the name of the sample file which the sound
// will record, in addition to the server object pointer. The Sound Object
// itself is created by snerd on snerd's side.Snerd is managing the data and
// return just the Handle to it           
bergenRecord::bergenRecord(char *filename,bergenServer *server) : bergenSound(server)
	{
	if (filename)
		{
		filename_ = strdup(filename);
		createRemote();
		}
	else
		{
		fprintf(stderr,"ERROR: bergenRecord created with NULL file name\n");
		filename_ = NULL;
		}
	}


// Creates Fullpath bz calling fullpath and sends message to the associated
// server to create a sound sample and waits for the resulting handle to store
void bergenRecord::createRemote(void)
	{
	if (server_)
		{
		char cmd[256];
		sprintf(cmd,"-1 new recordfile %s %d",filename_,server_->listener()->handle());
		server_->sendMessage(cmd);
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Sends a message to the server program to start recording the sound.
void bergenRecord::record(void)
{
	if (server_)
	{
		char message[256];
		sprintf(message,"%d record", handle_);
		server_->sendMessage(message);
	}
}
