#include <stdio.h>
#include <stdlib.h>
#include "bergenListener.h"
#include "bergenServer.h"
#include "bergenTone.h"


// Creates the tone sound object 
bergenTone::bergenTone(bergenServer *server) : bergenSound(server)
	{
	createRemote();
	}


// Creates new Tone Objekt by sending a message to the server to create it 
void bergenTone::createRemote(void)
	{
	if (server_)
		{
		char cmd[256];
		sprintf(cmd,"-1 new tone %d",server_->listener()->handle());
		server_->sendMessage(cmd);
		handle_ = server_->receiveHandle();
		}
	else
		handle_ = 0;
	}


// Sets the frequency of the sound to be freq cycles per second. The default
// frequency is 1000 Hz.
void bergenTone::setFrequency(float freq)
	{
	if (server_)
		{
		char message[256];
		sprintf(message,"%d setfrequency %.2f",handle_,freq);
		server_->sendMessage(message);
		}
	}

