#ifndef _AudioInterface_h_
#define _AudioInterface_h_

#ifdef __sgi
#include <dmedia/audio.h>
#else
typedef int ALport;
#endif

class AudioInterface 
	{
	public:
	 static void openOutputPort(int bufsize,int sampleRate,int channels);
	 static void openInputPort(int bufsize,int sampleRate, int channels);
	 static int writeOutputPort(void *buffer,size_t bufsize);
	 static int readInputPort(void *buffer,size_t bufsize);
	 static void fillInputPort(void);
	 inline static int bufferSize(void) { return bufferSize_; };
	 inline static int outputRate(void) { return outputRate_; };
	 inline static int inputRate(void) { return inputRate_; };
	 inline static ALport outputPort(void) { return outputPort_; };
	 inline static ALport inputPort(void) { return inputPort_; };
	 inline static int outputChannels(void) { return outputChannels_; };
	 inline static int inputChannels(void) { return inputChannels_; };
	 inline static int inputBufferReady(void) { return inputBufferReady_; };
	 inline static int inputReadError(void) { return inputReadError_; };
	private:
	 static int bufferSize_;
	 static int outputRate_;
	 static int inputRate_;
	 static ALport outputPort_;
	 static ALport inputPort_;
	 static int outputChannels_;
	 static int inputChannels_;
	 static int inputBufferReady_;
	 static int inputReadError_;
	 static short * inputBuffer_;
	};

#endif
