#ifndef _Listener_h_
#define _Listener_h_

#include "snerdConfig.h"

class Listener
		{
		public:
		 Listener(ConfigInformation* config,char* addr);
		 ~Listener(void);
		 void setAddress(char* addr);
		 virtual void setPosition(float x, float y, float z);
		 virtual void setSpeakerPosition(int speakerIndex, float x, float y, float z);
		 inline int handle(void) { return handle_; };
		 inline float positionX(void) { return positionX_; };
		 inline float positionY(void) { return positionY_; };
		 inline float positionZ(void) { return positionZ_; };
		 inline int numSpeakers(void) { return config_->numSpeakers; };
		 inline char* address(void) { return address_; };
		 inline SpeakerInformation** speakers(void) { return config_->speakers; };
		 virtual void message(char **msg,int num);
		 virtual void kill(void);
		 virtual int removable(void);
		 void updatePosition(void);
		private:
		 void updateSpeakers(void);
		 ConfigInformation* config_;
		 float reportedX_;
		 float reportedY_;
		 float reportedZ_;
		 float positionX_;
		 float positionY_;
		 float positionZ_;
		protected:
		 int handle_; 
		 static int NextHandle;
		 int killed_;
		 char address_[32];
		};
#endif
