#ifndef _OSCServer_h_
#define _OSCServer_h_

#include "snerdConfig.h"

extern "C"
{
#include <OSC-client.h>
}

class OSCServer
	{
	public:
	 static void init(ConfigInformation* config);
	 static void mainLoop(void);
	 static void sendMessage(void *msg,int len);
	 static void sendOSCString(char* r,char* s);
	 static void sendOSCStringVec3(char* r,char* s,float* v);
	 static void sendOSCBuffer(void);
	 static ConfigInformation* config_;
	private:
	 static void processMessages(void);
	 static int splitMessage(char *message,char **strings,int max);
	 static void parseMessage(char **message,int numStrings);
	 static void parseNewSoundMessage(char **message,int numStrings);
	 static int receiveOSCHandle(void);
	 static int parseOSCPacket(char *buf, int n, char **strings, int max, int pos);
	 static int smessage(char*, void *v, int n, char **strings, int max, int pos);
	 static int parseTypeTaggedArgs(void *v, int n, char **strings, int max, int pos);
	 static int parseHeuristicallyTypeGuessedArgs(void *v, int n, int skipComma, char **strings, int max, int pos);
	 static char *dataAfterAlignedString(char *string, char *boundary) ;
	 static bool isNiceString(char *string, char *boundary) ;
	 static class bergenUDPSocket* rcvSocket_;
	 static class bergenUDPSocket* sndSocket_;
	 static bool looping_;
	 static int socket_osc_;
	 static void * socket_htm_osc_;
	 static OSCbuf buf[1];
	 static char bufferForOSCbuf[500];
	};

#endif
