#ifndef _RATStream_h_
#define _RATStream_h_

#ifdef AUDIOFILE_LIBRARY

#ifdef __sgi
#include <dmedia/audiofile.h>
#else
#include <audiofile.h>
#endif

#else
/* No SGI audiofile library */
typedef int AFfilehandle;
#define AF_NULL_FILEHANDLE 0
#define AF_SAMPFMT_TWOSCOMP 1
#define AF_SAMPFMT_UNSIGNED 2

#endif


#include "ASound.h"

#ifdef COMMON_LIBRARY
#include "mbus.h"
#endif

class RATSource: public ASound
		{
		public:
		 RATSource(char *source, snerdDB* sDB, int listener, ConfigInformation* config);
		 ~RATSource(void);
		 void setSource(char* source);
		 void setSourceGain(float val);
		 void set3DEnable(int val);
		 void setSource3DAzimuth(float val);
		 float sourceAzimuth(void);
		 virtual char * source(void);
		 virtual void play(void);
		 virtual void stop(void);
		 virtual void pause(void);
		 virtual void kill(void);
		 virtual short * updateBuffer(void);
		 virtual int removable(void);
		 virtual int active(void);
		 virtual void message(char **,int);
		private:
		 void initializeMbus(void);
		 char* source_;
		 int enabled3D_;
		 float sourceGain_;
		 float sourceAzimuth_;
		 float azimuthThresh_;
		 float gainThresh_;
		 static char snerd_addr[60];
		 static char engine_addr[60];
		 static char ui_addr[60];
		 static int pid;
		 static float updateInterval;
		 float lastUpdate;
		 long startTime;
#ifdef COMMON_LIBRARY
		 static struct mbus* m;
#else
		 static void* m;
#endif
		 int playing_;
		 int killed_;
		};

#endif
